%%

%public
%class ScannerJFlex
%implements Tokens
%function leToken
%type Token

%%

[ \n\r\t]    { }

[0-9]+  { return new Token(NUM, yytext()); }

write    { return new Token(WRITE, yytext()); }
read    { return new Token(READ, yytext()); }
if    { return new Token(IF, yytext()); }
then    { return new Token(THEN, yytext()); }
else    { return new Token(ELSE, yytext()); }
end    { return new Token(END, yytext()); }
repeat    { return new Token(REPEAT, yytext()); }
until    { return new Token(UNTIL, yytext()); }
var    { return new Token(VAR, yytext()); }
procedure { return new Token(PROCEDURE, yytext()); }
int    { return new Token(INT, yytext()); }
real   { return new Token(REAL, yytext()); }
bool   { return new Token(BOOL, yytext()); }
return { return new Token(RETURN, yytext()); }
begin  { return new Token(BEGIN, yytext()); }

[a-zA-Z][a-zA-Z0-9_]* { return new Token(ID, yytext()); }

[+]  { return new Token('+', yytext()); }
[-]  { return new Token('-', yytext()); }
[*]  { return new Token('*', yytext()); }
[/]  { return new Token('/', yytext()); }
[=]  { return new Token('=', yytext()); }
[<]  { return new Token('<', yytext()); }
[(]  { return new Token('(', yytext()); }
[)]  { return new Token(')', yytext()); }
;    { return new Token(';', yytext()); }
,    { return new Token(',', yytext()); }
[:][=] { return new Token(ATRIB, yytext()); }
[:]  { return new Token(':', yytext()); }

<<EOF>>    { return new Token(0, "<<EOF>>"); }

.          { throw new RuntimeException("caractere inv�lido "+yytext()); }
